<html>
<head>
<title>OgreSceneQuery.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreSceneQuery.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreSceneQuery_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __SceneQuery_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __SceneQuery_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreAxisAlignedBox_8h.html">OgreAxisAlignedBox.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreSphere_8h.html">OgreSphere.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreRay_8h.html">OgreRay.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderOperation_8h.html">OgreRenderOperation.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgrePlaneBoundedVolume_8h.html">OgrePlaneBoundedVolume.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre {
<a name="l00039"></a>00039 
<a name="l00040"></a>00040     <span class="comment">// forward declaration</span>
<a name="l00041"></a>00041     <span class="keyword">class </span>SceneQueryListener;
<a name="l00073"></a><a class="code" href="classOgre_1_1SceneQuery.html">00073</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1SceneQuery.html" title="A class for performing queries on a scene.">SceneQuery</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">SceneMgtAlloc</a>
<a name="l00074"></a>00074     {
<a name="l00075"></a>00075     <span class="keyword">public</span>:
<a name="l00082"></a><a class="code" href="classOgre_1_1SceneQuery.html#a0a75b5ed976da2f9023382f4c4514b3a">00082</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1SceneQuery.html#a0a75b5ed976da2f9023382f4c4514b3a" title="This type can be used by collaborating applications &amp; SceneManagers to agree on the type of world geo...">WorldFragmentType</a> {
<a name="l00084"></a><a class="code" href="classOgre_1_1SceneQuery.html#a0a75b5ed976da2f9023382f4c4514b3aa6ed287fab168d451beb369009f0fd03b">00084</a>             <a class="code" href="classOgre_1_1SceneQuery.html#a0a75b5ed976da2f9023382f4c4514b3aa6ed287fab168d451beb369009f0fd03b" title="Return no world geometry hits at all.">WFT_NONE</a>,
<a name="l00086"></a><a class="code" href="classOgre_1_1SceneQuery.html#a0a75b5ed976da2f9023382f4c4514b3aa667bbec7031e58ab244f9efc32056f38">00086</a>             <a class="code" href="classOgre_1_1SceneQuery.html#a0a75b5ed976da2f9023382f4c4514b3aa667bbec7031e58ab244f9efc32056f38" title="Return pointers to convex plane-bounded regions.">WFT_PLANE_BOUNDED_REGION</a>,
<a name="l00088"></a><a class="code" href="classOgre_1_1SceneQuery.html#a0a75b5ed976da2f9023382f4c4514b3aa018493b6c87271e0c8ba014f058cffd3">00088</a>             <a class="code" href="classOgre_1_1SceneQuery.html#a0a75b5ed976da2f9023382f4c4514b3aa018493b6c87271e0c8ba014f058cffd3" title="Return a single intersection point (typically RaySceneQuery only)">WFT_SINGLE_INTERSECTION</a>,
<a name="l00090"></a><a class="code" href="classOgre_1_1SceneQuery.html#a0a75b5ed976da2f9023382f4c4514b3aadeefa0cc2dfd1ec783c2a266ea61f925">00090</a>             <a class="code" href="classOgre_1_1SceneQuery.html#a0a75b5ed976da2f9023382f4c4514b3aadeefa0cc2dfd1ec783c2a266ea61f925" title="Custom geometry as defined by the SceneManager.">WFT_CUSTOM_GEOMETRY</a>,
<a name="l00092"></a><a class="code" href="classOgre_1_1SceneQuery.html#a0a75b5ed976da2f9023382f4c4514b3aad498944c8c6b81d737c3ceee86881e8d">00092</a>             WFT_RENDER_OPERATION
<a name="l00093"></a>00093         };
<a name="l00094"></a>00094 
<a name="l00108"></a><a class="code" href="structOgre_1_1SceneQuery_1_1WorldFragment.html">00108</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1SceneQuery_1_1WorldFragment.html" title="Represents part of the world geometry that is a result of a SceneQuery.">WorldFragment</a> {
<a name="l00110"></a><a class="code" href="structOgre_1_1SceneQuery_1_1WorldFragment.html#a57f755adea8044729adff811f61f1a60">00110</a>             <a class="code" href="classOgre_1_1SceneQuery.html#a0a75b5ed976da2f9023382f4c4514b3a" title="This type can be used by collaborating applications &amp; SceneManagers to agree on the type of world geo...">WorldFragmentType</a> <a class="code" href="structOgre_1_1SceneQuery_1_1WorldFragment.html#a57f755adea8044729adff811f61f1a60" title="The type of this world fragment.">fragmentType</a>;
<a name="l00112"></a><a class="code" href="structOgre_1_1SceneQuery_1_1WorldFragment.html#abfe0314db3e89040486ceb1ba36a8682">00112</a>             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="structOgre_1_1SceneQuery_1_1WorldFragment.html#abfe0314db3e89040486ceb1ba36a8682" title="Single intersection point, only applicable for WFT_SINGLE_INTERSECTION.">singleIntersection</a>;
<a name="l00114"></a><a class="code" href="structOgre_1_1SceneQuery_1_1WorldFragment.html#a9ce184deb8bec05fc875ff23be86447f">00114</a>             <a class="code" href="structOgre_1_1list.html">list&lt;Plane&gt;::type</a>* <a class="code" href="structOgre_1_1SceneQuery_1_1WorldFragment.html#a9ce184deb8bec05fc875ff23be86447f" title="Planes bounding a convex region, only applicable for WFT_PLANE_BOUNDED_REGION.">planes</a>;
<a name="l00116"></a><a class="code" href="structOgre_1_1SceneQuery_1_1WorldFragment.html#af83de2ae922b7f41d25b930705836378">00116</a>             <span class="keywordtype">void</span>* <a class="code" href="structOgre_1_1SceneQuery_1_1WorldFragment.html#af83de2ae922b7f41d25b930705836378" title="Custom geometry block, only applicable for WFT_CUSTOM_GEOMETRY.">geometry</a>;
<a name="l00118"></a><a class="code" href="structOgre_1_1SceneQuery_1_1WorldFragment.html#a54bfeacb15a22824625be72012600416">00118</a>             <a class="code" href="classOgre_1_1RenderOperation.html" title="&#39;New&#39; rendering operation using vertex buffers.">RenderOperation</a>* <a class="code" href="structOgre_1_1SceneQuery_1_1WorldFragment.html#a54bfeacb15a22824625be72012600416" title="General render operation structure, fallback if nothing else is available.">renderOp</a>;
<a name="l00119"></a>00119             
<a name="l00120"></a>00120         };
<a name="l00121"></a>00121     <span class="keyword">protected</span>:
<a name="l00122"></a><a class="code" href="classOgre_1_1SceneQuery.html#a36c06292c148746a8950b5c3c60b63a7">00122</a>         <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* <a class="code" href="classOgre_1_1SceneQuery.html#a36c06292c148746a8950b5c3c60b63a7">mParentSceneMgr</a>;
<a name="l00123"></a><a class="code" href="classOgre_1_1SceneQuery.html#a1ab71f92378d94fc42b48c7bf8d9b5a0">00123</a>         <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="classOgre_1_1SceneQuery.html#a1ab71f92378d94fc42b48c7bf8d9b5a0">mQueryMask</a>;
<a name="l00124"></a><a class="code" href="classOgre_1_1SceneQuery.html#ab6bea8046f722f02c27b0c0de794f13d">00124</a>         <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="classOgre_1_1SceneQuery.html#ab6bea8046f722f02c27b0c0de794f13d">mQueryTypeMask</a>;
<a name="l00125"></a><a class="code" href="classOgre_1_1SceneQuery.html#aa1ad40080bc4490f795ff8fb8a4edf4a">00125</a>         <a class="code" href="structOgre_1_1set.html">set&lt;WorldFragmentType&gt;::type</a> <a class="code" href="classOgre_1_1SceneQuery.html#aa1ad40080bc4490f795ff8fb8a4edf4a">mSupportedWorldFragments</a>;
<a name="l00126"></a><a class="code" href="classOgre_1_1SceneQuery.html#a9cef909c3f78d2e9f3ef44ca8c2cfdaa">00126</a>         <a class="code" href="classOgre_1_1SceneQuery.html#a0a75b5ed976da2f9023382f4c4514b3a" title="This type can be used by collaborating applications &amp; SceneManagers to agree on the type of world geo...">WorldFragmentType</a> <a class="code" href="classOgre_1_1SceneQuery.html#a9cef909c3f78d2e9f3ef44ca8c2cfdaa">mWorldFragmentType</a>;
<a name="l00127"></a>00127     
<a name="l00128"></a>00128     <span class="keyword">public</span>:
<a name="l00130"></a>00130         <a class="code" href="classOgre_1_1SceneQuery.html" title="A class for performing queries on a scene.">SceneQuery</a>(<a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* mgr);
<a name="l00131"></a>00131         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1SceneQuery.html" title="A class for performing queries on a scene.">SceneQuery</a>();
<a name="l00132"></a>00132 
<a name="l00142"></a>00142         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setQueryMask(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> mask);
<a name="l00144"></a>00144         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> getQueryMask(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00145"></a>00145 
<a name="l00154"></a>00154         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setQueryTypeMask(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> mask);
<a name="l00156"></a>00156         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> getQueryTypeMask(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00157"></a>00157 
<a name="l00168"></a>00168         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setWorldFragmentType(<span class="keyword">enum</span> <a class="code" href="classOgre_1_1SceneQuery.html#a0a75b5ed976da2f9023382f4c4514b3a" title="This type can be used by collaborating applications &amp; SceneManagers to agree on the type of world geo...">WorldFragmentType</a> wft);
<a name="l00169"></a>00169 
<a name="l00171"></a>00171         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SceneQuery.html#a0a75b5ed976da2f9023382f4c4514b3a" title="This type can be used by collaborating applications &amp; SceneManagers to agree on the type of world geo...">WorldFragmentType</a> getWorldFragmentType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00172"></a>00172 
<a name="l00174"></a><a class="code" href="classOgre_1_1SceneQuery.html#ab900f61543657dcbab7d62245021a75f">00174</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="structOgre_1_1set.html">set&lt;WorldFragmentType&gt;::type</a>* getSupportedWorldFragmentTypes(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00175"></a>00175 <span class="keyword">            </span>{<span class="keywordflow">return</span> &amp;mSupportedWorldFragments;}
<a name="l00176"></a>00176 
<a name="l00177"></a>00177         
<a name="l00178"></a>00178     };
<a name="l00179"></a>00179 
<a name="l00186"></a><a class="code" href="classOgre_1_1SceneQueryListener.html">00186</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1SceneQueryListener.html" title="This optional class allows you to receive per-result callbacks from SceneQuery executions instead of ...">SceneQueryListener</a>
<a name="l00187"></a>00187     {
<a name="l00188"></a>00188     <span class="keyword">public</span>:
<a name="l00189"></a><a class="code" href="classOgre_1_1SceneQueryListener.html#ad0ea5280ec1032a5170999eb7ae3fb2b">00189</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SceneQueryListener.html#ad0ea5280ec1032a5170999eb7ae3fb2b">~SceneQueryListener</a>() { }
<a name="l00195"></a>00195         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> queryResult(<a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>* <span class="keywordtype">object</span>) = 0;
<a name="l00201"></a>00201         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> queryResult(<a class="code" href="structOgre_1_1SceneQuery_1_1WorldFragment.html" title="Represents part of the world geometry that is a result of a SceneQuery.">SceneQuery::WorldFragment</a>* fragment) = 0;
<a name="l00202"></a>00202 
<a name="l00203"></a>00203     };
<a name="l00204"></a>00204 
<a name="l00205"></a><a class="code" href="group__Scene.html#gad79dcd1262d117ecf4d51a5f555d3071">00205</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1list.html">list&lt;MovableObject*&gt;::type</a> <a class="code" href="group__Scene.html#gad79dcd1262d117ecf4d51a5f555d3071">SceneQueryResultMovableList</a>;
<a name="l00206"></a><a class="code" href="group__Scene.html#gad9005a54a736be79548ebcdf69dfd448">00206</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1list.html">list&lt;SceneQuery::WorldFragment*&gt;::type</a> <a class="code" href="group__Scene.html#gad9005a54a736be79548ebcdf69dfd448">SceneQueryResultWorldFragmentList</a>;
<a name="l00208"></a><a class="code" href="structOgre_1_1SceneQueryResult.html">00208</a>     <span class="keyword">struct </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="structOgre_1_1SceneQueryResult.html" title="Holds the results of a scene query.">SceneQueryResult</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">SceneMgtAlloc</a>
<a name="l00209"></a>00209     {
<a name="l00211"></a><a class="code" href="structOgre_1_1SceneQueryResult.html#a2224618a99dc451317e56082697b1ffa">00211</a>         <a class="code" href="group__Scene.html#gad79dcd1262d117ecf4d51a5f555d3071">SceneQueryResultMovableList</a> <a class="code" href="structOgre_1_1SceneQueryResult.html#a2224618a99dc451317e56082697b1ffa" title="List of movable objects in the query (entities, particle systems etc)">movables</a>;
<a name="l00213"></a><a class="code" href="structOgre_1_1SceneQueryResult.html#a8157783aec3ca4d9566a9a6bfe08fee0">00213</a>         <a class="code" href="group__Scene.html#gad9005a54a736be79548ebcdf69dfd448">SceneQueryResultWorldFragmentList</a> <a class="code" href="structOgre_1_1SceneQueryResult.html#a8157783aec3ca4d9566a9a6bfe08fee0" title="List of world fragments.">worldFragments</a>;
<a name="l00214"></a>00214     };
<a name="l00215"></a>00215 
<a name="l00222"></a><a class="code" href="classOgre_1_1RegionSceneQuery.html">00222</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1RegionSceneQuery.html" title="Abstract class defining a query which returns single results from a region.">RegionSceneQuery</a>
<a name="l00223"></a>00223         : <span class="keyword">public</span> <a class="code" href="classOgre_1_1SceneQuery.html" title="A class for performing queries on a scene.">SceneQuery</a>, <span class="keyword">public</span> <a class="code" href="classOgre_1_1SceneQueryListener.html" title="This optional class allows you to receive per-result callbacks from SceneQuery executions instead of ...">SceneQueryListener</a>
<a name="l00224"></a>00224     {
<a name="l00225"></a>00225     <span class="keyword">protected</span>:
<a name="l00226"></a><a class="code" href="classOgre_1_1RegionSceneQuery.html#acf71b48a7b75f0a13eeb49161fb26b9f">00226</a>         <a class="code" href="structOgre_1_1SceneQueryResult.html" title="Holds the results of a scene query.">SceneQueryResult</a>* <a class="code" href="classOgre_1_1RegionSceneQuery.html#acf71b48a7b75f0a13eeb49161fb26b9f">mLastResult</a>;
<a name="l00227"></a>00227     <span class="keyword">public</span>:
<a name="l00229"></a>00229         <a class="code" href="classOgre_1_1RegionSceneQuery.html" title="Abstract class defining a query which returns single results from a region.">RegionSceneQuery</a>(<a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* mgr);
<a name="l00230"></a>00230         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1RegionSceneQuery.html" title="Abstract class defining a query which returns single results from a region.">RegionSceneQuery</a>();
<a name="l00239"></a>00239         <span class="keyword">virtual</span> <a class="code" href="structOgre_1_1SceneQueryResult.html" title="Holds the results of a scene query.">SceneQueryResult</a>&amp; execute(<span class="keywordtype">void</span>);
<a name="l00240"></a>00240 
<a name="l00248"></a>00248         <span class="keyword">virtual</span> <span class="keywordtype">void</span> execute(<a class="code" href="classOgre_1_1SceneQueryListener.html" title="This optional class allows you to receive per-result callbacks from SceneQuery executions instead of ...">SceneQueryListener</a>* listener) = 0;
<a name="l00249"></a>00249         
<a name="l00253"></a>00253         <span class="keyword">virtual</span> <a class="code" href="structOgre_1_1SceneQueryResult.html" title="Holds the results of a scene query.">SceneQueryResult</a>&amp; getLastResults(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00260"></a>00260         <span class="keyword">virtual</span> <span class="keywordtype">void</span> clearResults(<span class="keywordtype">void</span>);
<a name="l00261"></a>00261 
<a name="l00263"></a>00263         <span class="keywordtype">bool</span> queryResult(<a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>* first);
<a name="l00265"></a>00265         <span class="keywordtype">bool</span> queryResult(<a class="code" href="structOgre_1_1SceneQuery_1_1WorldFragment.html" title="Represents part of the world geometry that is a result of a SceneQuery.">SceneQuery::WorldFragment</a>* fragment);
<a name="l00266"></a>00266     };
<a name="l00267"></a>00267 
<a name="l00269"></a><a class="code" href="classOgre_1_1AxisAlignedBoxSceneQuery.html">00269</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1AxisAlignedBoxSceneQuery.html" title="Specialises the SceneQuery class for querying within an axis aligned box.">AxisAlignedBoxSceneQuery</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1RegionSceneQuery.html" title="Abstract class defining a query which returns single results from a region.">RegionSceneQuery</a>
<a name="l00270"></a>00270     {
<a name="l00271"></a>00271     <span class="keyword">protected</span>:
<a name="l00272"></a><a class="code" href="classOgre_1_1AxisAlignedBoxSceneQuery.html#a65b698ee00135e3f97a45de211d62254">00272</a>         <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a> <a class="code" href="classOgre_1_1AxisAlignedBoxSceneQuery.html#a65b698ee00135e3f97a45de211d62254">mAABB</a>;
<a name="l00273"></a>00273     <span class="keyword">public</span>:
<a name="l00274"></a>00274         <a class="code" href="classOgre_1_1AxisAlignedBoxSceneQuery.html" title="Specialises the SceneQuery class for querying within an axis aligned box.">AxisAlignedBoxSceneQuery</a>(<a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* mgr);
<a name="l00275"></a>00275         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1AxisAlignedBoxSceneQuery.html" title="Specialises the SceneQuery class for querying within an axis aligned box.">AxisAlignedBoxSceneQuery</a>();
<a name="l00276"></a>00276 
<a name="l00278"></a>00278         <span class="keywordtype">void</span> setBox(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; box);
<a name="l00279"></a>00279 
<a name="l00281"></a>00281         <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; getBox(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00282"></a>00282 
<a name="l00283"></a>00283     };
<a name="l00284"></a>00284 
<a name="l00286"></a><a class="code" href="classOgre_1_1SphereSceneQuery.html">00286</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1SphereSceneQuery.html" title="Specialises the SceneQuery class for querying within a sphere.">SphereSceneQuery</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1RegionSceneQuery.html" title="Abstract class defining a query which returns single results from a region.">RegionSceneQuery</a>
<a name="l00287"></a>00287     {
<a name="l00288"></a>00288     <span class="keyword">protected</span>:
<a name="l00289"></a><a class="code" href="classOgre_1_1SphereSceneQuery.html#ac5c07ea44a8ca10ee63c2fa882b07521">00289</a>         <a class="code" href="classOgre_1_1Sphere.html" title="A sphere primitive, mostly used for bounds checking.">Sphere</a> <a class="code" href="classOgre_1_1SphereSceneQuery.html#ac5c07ea44a8ca10ee63c2fa882b07521">mSphere</a>;
<a name="l00290"></a>00290     <span class="keyword">public</span>:
<a name="l00291"></a>00291         <a class="code" href="classOgre_1_1SphereSceneQuery.html" title="Specialises the SceneQuery class for querying within a sphere.">SphereSceneQuery</a>(<a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* mgr);
<a name="l00292"></a>00292         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1SphereSceneQuery.html" title="Specialises the SceneQuery class for querying within a sphere.">SphereSceneQuery</a>();
<a name="l00294"></a>00294         <span class="keywordtype">void</span> setSphere(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Sphere.html" title="A sphere primitive, mostly used for bounds checking.">Sphere</a>&amp; sphere);
<a name="l00295"></a>00295 
<a name="l00297"></a>00297         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Sphere.html" title="A sphere primitive, mostly used for bounds checking.">Sphere</a>&amp; getSphere() <span class="keyword">const</span>;
<a name="l00298"></a>00298 
<a name="l00299"></a>00299     };
<a name="l00300"></a>00300 
<a name="l00303"></a><a class="code" href="classOgre_1_1PlaneBoundedVolumeListSceneQuery.html">00303</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1PlaneBoundedVolumeListSceneQuery.html" title="Specialises the SceneQuery class for querying within a plane-bounded volume.">PlaneBoundedVolumeListSceneQuery</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1RegionSceneQuery.html" title="Abstract class defining a query which returns single results from a region.">RegionSceneQuery</a>
<a name="l00304"></a>00304     {
<a name="l00305"></a>00305     <span class="keyword">protected</span>:
<a name="l00306"></a><a class="code" href="classOgre_1_1PlaneBoundedVolumeListSceneQuery.html#a3c9e7972e74e08c1743683d9d288dfd9">00306</a>         <a class="code" href="group__Math.html#ga6253a1300d656ba28342fe58260d0e71">PlaneBoundedVolumeList</a> <a class="code" href="classOgre_1_1PlaneBoundedVolumeListSceneQuery.html#a3c9e7972e74e08c1743683d9d288dfd9">mVolumes</a>;
<a name="l00307"></a>00307     <span class="keyword">public</span>:
<a name="l00308"></a>00308         <a class="code" href="classOgre_1_1PlaneBoundedVolumeListSceneQuery.html" title="Specialises the SceneQuery class for querying within a plane-bounded volume.">PlaneBoundedVolumeListSceneQuery</a>(<a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* mgr);
<a name="l00309"></a>00309         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1PlaneBoundedVolumeListSceneQuery.html" title="Specialises the SceneQuery class for querying within a plane-bounded volume.">PlaneBoundedVolumeListSceneQuery</a>();
<a name="l00311"></a>00311         <span class="keywordtype">void</span> setVolumes(<span class="keyword">const</span> <a class="code" href="group__Math.html#ga6253a1300d656ba28342fe58260d0e71">PlaneBoundedVolumeList</a>&amp; volumes);
<a name="l00312"></a>00312 
<a name="l00314"></a>00314         <span class="keyword">const</span> <a class="code" href="group__Math.html#ga6253a1300d656ba28342fe58260d0e71">PlaneBoundedVolumeList</a>&amp; getVolumes() <span class="keyword">const</span>;
<a name="l00315"></a>00315 
<a name="l00316"></a>00316     };
<a name="l00317"></a>00317 
<a name="l00318"></a>00318 
<a name="l00319"></a>00319     <span class="comment">/*</span>
<a name="l00321"></a>00321 <span class="comment">    class _OgreExport PyramidSceneQuery : public RegionSceneQuery</span>
<a name="l00322"></a>00322 <span class="comment">    {</span>
<a name="l00323"></a>00323 <span class="comment">    public:</span>
<a name="l00324"></a>00324 <span class="comment">        PyramidSceneQuery(SceneManager* mgr);</span>
<a name="l00325"></a>00325 <span class="comment">        virtual ~PyramidSceneQuery();</span>
<a name="l00326"></a>00326 <span class="comment">    };</span>
<a name="l00327"></a>00327 <span class="comment">    */</span>
<a name="l00328"></a>00328 
<a name="l00334"></a><a class="code" href="classOgre_1_1RaySceneQueryListener.html">00334</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1RaySceneQueryListener.html" title="Alternative listener class for dealing with RaySceneQuery.">RaySceneQueryListener</a> 
<a name="l00335"></a>00335     {
<a name="l00336"></a>00336     <span class="keyword">public</span>:
<a name="l00337"></a><a class="code" href="classOgre_1_1RaySceneQueryListener.html#a055ea5aff0165926892ad74289d2f73c">00337</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RaySceneQueryListener.html#a055ea5aff0165926892ad74289d2f73c">~RaySceneQueryListener</a>() { }
<a name="l00344"></a>00344         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> queryResult(<a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>* obj, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> distance) = 0;
<a name="l00345"></a>00345 
<a name="l00352"></a>00352         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> queryResult(<a class="code" href="structOgre_1_1SceneQuery_1_1WorldFragment.html" title="Represents part of the world geometry that is a result of a SceneQuery.">SceneQuery::WorldFragment</a>* fragment, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> distance) = 0;
<a name="l00353"></a>00353 
<a name="l00354"></a>00354     };
<a name="l00355"></a>00355       
<a name="l00357"></a><a class="code" href="structOgre_1_1RaySceneQueryResultEntry.html">00357</a>     <span class="keyword">struct </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="structOgre_1_1RaySceneQueryResultEntry.html" title="This struct allows a single comparison of result data no matter what the type.">RaySceneQueryResultEntry</a>
<a name="l00358"></a>00358     {
<a name="l00360"></a><a class="code" href="structOgre_1_1RaySceneQueryResultEntry.html#af3e8eed523c4215c5733a9886db7ec29">00360</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="structOgre_1_1RaySceneQueryResultEntry.html#af3e8eed523c4215c5733a9886db7ec29" title="Distance along the ray.">distance</a>;
<a name="l00362"></a><a class="code" href="structOgre_1_1RaySceneQueryResultEntry.html#a58ba184768924a39ab195dcf96472f65">00362</a>         <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>* <a class="code" href="structOgre_1_1RaySceneQueryResultEntry.html#a58ba184768924a39ab195dcf96472f65" title="The movable, or NULL if this is not a movable result.">movable</a>;
<a name="l00364"></a><a class="code" href="structOgre_1_1RaySceneQueryResultEntry.html#acc6655f373532d7b9d3017acab7535a9">00364</a>         <a class="code" href="structOgre_1_1SceneQuery_1_1WorldFragment.html" title="Represents part of the world geometry that is a result of a SceneQuery.">SceneQuery::WorldFragment</a>* <a class="code" href="structOgre_1_1RaySceneQueryResultEntry.html#acc6655f373532d7b9d3017acab7535a9" title="The world fragment, or NULL if this is not a fragment result.">worldFragment</a>;
<a name="l00366"></a><a class="code" href="structOgre_1_1RaySceneQueryResultEntry.html#a34a0b8081991ce12025445ae35117ca6">00366</a>         <span class="keywordtype">bool</span> <a class="code" href="group__General.html#gae1dbf4506ab2500da5ec4ef0b58cb2e1">operator &lt; </a>(<span class="keyword">const</span> <a class="code" href="structOgre_1_1RaySceneQueryResultEntry.html" title="This struct allows a single comparison of result data no matter what the type.">RaySceneQueryResultEntry</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00367"></a>00367 <span class="keyword">        </span>{
<a name="l00368"></a>00368             <span class="keywordflow">return</span> this-&gt;distance &lt; rhs.<a class="code" href="structOgre_1_1RaySceneQueryResultEntry.html#af3e8eed523c4215c5733a9886db7ec29" title="Distance along the ray.">distance</a>;
<a name="l00369"></a>00369         }
<a name="l00370"></a>00370 
<a name="l00371"></a>00371     };
<a name="l00372"></a><a class="code" href="group__Scene.html#ga1d0db569747448aeff27f36ecd717686">00372</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;RaySceneQueryResultEntry&gt;::type</a> <a class="code" href="group__Scene.html#ga1d0db569747448aeff27f36ecd717686">RaySceneQueryResult</a>;
<a name="l00373"></a>00373 
<a name="l00375"></a><a class="code" href="classOgre_1_1RaySceneQuery.html">00375</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1RaySceneQuery.html" title="Specialises the SceneQuery class for querying along a ray.">RaySceneQuery</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1SceneQuery.html" title="A class for performing queries on a scene.">SceneQuery</a>, <span class="keyword">public</span> <a class="code" href="classOgre_1_1RaySceneQueryListener.html" title="Alternative listener class for dealing with RaySceneQuery.">RaySceneQueryListener</a>
<a name="l00376"></a>00376     {
<a name="l00377"></a>00377     <span class="keyword">protected</span>:
<a name="l00378"></a><a class="code" href="classOgre_1_1RaySceneQuery.html#a549a2d58803cafe0f5c0e36e750e58e6">00378</a>         <a class="code" href="classOgre_1_1Ray.html" title="Representation of a ray in space, i.e.">Ray</a> <a class="code" href="classOgre_1_1RaySceneQuery.html#a549a2d58803cafe0f5c0e36e750e58e6">mRay</a>;
<a name="l00379"></a><a class="code" href="classOgre_1_1RaySceneQuery.html#a90940fd45a737eb1c23d19045a875999">00379</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1RaySceneQuery.html#a90940fd45a737eb1c23d19045a875999">mSortByDistance</a>;
<a name="l00380"></a><a class="code" href="classOgre_1_1RaySceneQuery.html#a37493a877c05ae2cd72c343c037418f9">00380</a>         <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> <a class="code" href="classOgre_1_1RaySceneQuery.html#a37493a877c05ae2cd72c343c037418f9">mMaxResults</a>;
<a name="l00381"></a><a class="code" href="classOgre_1_1RaySceneQuery.html#a6703cadb44854b231a12d4e399d64aab">00381</a>         <a class="code" href="group__Scene.html#ga1d0db569747448aeff27f36ecd717686">RaySceneQueryResult</a> <a class="code" href="classOgre_1_1RaySceneQuery.html#a6703cadb44854b231a12d4e399d64aab">mResult</a>;
<a name="l00382"></a>00382 
<a name="l00383"></a>00383     <span class="keyword">public</span>:
<a name="l00384"></a>00384         <a class="code" href="classOgre_1_1RaySceneQuery.html" title="Specialises the SceneQuery class for querying along a ray.">RaySceneQuery</a>(<a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* mgr);
<a name="l00385"></a>00385         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1RaySceneQuery.html" title="Specialises the SceneQuery class for querying along a ray.">RaySceneQuery</a>();
<a name="l00387"></a>00387         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setRay(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Ray.html" title="Representation of a ray in space, i.e.">Ray</a>&amp; ray);
<a name="l00389"></a>00389         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Ray.html" title="Representation of a ray in space, i.e.">Ray</a>&amp; getRay(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00408"></a>00408         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setSortByDistance(<span class="keywordtype">bool</span> sort, <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> maxresults = 0);
<a name="l00410"></a>00410         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> getSortByDistance(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00413"></a>00413         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> getMaxResults(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00422"></a>00422         <span class="keyword">virtual</span> <a class="code" href="group__Scene.html#ga1d0db569747448aeff27f36ecd717686">RaySceneQueryResult</a>&amp; execute(<span class="keywordtype">void</span>);
<a name="l00423"></a>00423 
<a name="l00431"></a>00431         <span class="keyword">virtual</span> <span class="keywordtype">void</span> execute(<a class="code" href="classOgre_1_1RaySceneQueryListener.html" title="Alternative listener class for dealing with RaySceneQuery.">RaySceneQueryListener</a>* listener) = 0;
<a name="l00432"></a>00432 
<a name="l00436"></a>00436         <span class="keyword">virtual</span> <a class="code" href="group__Scene.html#ga1d0db569747448aeff27f36ecd717686">RaySceneQueryResult</a>&amp; getLastResults(<span class="keywordtype">void</span>);
<a name="l00443"></a>00443         <span class="keyword">virtual</span> <span class="keywordtype">void</span> clearResults(<span class="keywordtype">void</span>);
<a name="l00444"></a>00444 
<a name="l00446"></a>00446         <span class="keywordtype">bool</span> queryResult(<a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>* obj, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> distance);
<a name="l00448"></a>00448         <span class="keywordtype">bool</span> queryResult(<a class="code" href="structOgre_1_1SceneQuery_1_1WorldFragment.html" title="Represents part of the world geometry that is a result of a SceneQuery.">SceneQuery::WorldFragment</a>* fragment, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> distance);
<a name="l00449"></a>00449 
<a name="l00450"></a>00450 
<a name="l00451"></a>00451 
<a name="l00452"></a>00452 
<a name="l00453"></a>00453     };
<a name="l00454"></a>00454 
<a name="l00460"></a><a class="code" href="classOgre_1_1IntersectionSceneQueryListener.html">00460</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1IntersectionSceneQueryListener.html" title="Alternative listener class for dealing with IntersectionSceneQuery.">IntersectionSceneQueryListener</a> 
<a name="l00461"></a>00461     {
<a name="l00462"></a>00462     <span class="keyword">public</span>:
<a name="l00463"></a><a class="code" href="classOgre_1_1IntersectionSceneQueryListener.html#a7537def6f0635fcf975b49f65e42e5c0">00463</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1IntersectionSceneQueryListener.html#a7537def6f0635fcf975b49f65e42e5c0">~IntersectionSceneQueryListener</a>() { }
<a name="l00470"></a>00470         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> queryResult(<a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>* first, <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>* second) = 0;
<a name="l00471"></a>00471 
<a name="l00478"></a>00478         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> queryResult(<a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>* movable, <a class="code" href="structOgre_1_1SceneQuery_1_1WorldFragment.html" title="Represents part of the world geometry that is a result of a SceneQuery.">SceneQuery::WorldFragment</a>* fragment) = 0;
<a name="l00479"></a>00479 
<a name="l00480"></a>00480         <span class="comment">/* NB there are no results for world fragments intersecting other world fragments;</span>
<a name="l00481"></a>00481 <span class="comment">           it is assumed that world geometry is either static or at least that self-intersections</span>
<a name="l00482"></a>00482 <span class="comment">           are irrelevant or dealt with elsewhere (such as the custom scene manager) */</span>
<a name="l00483"></a>00483         
<a name="l00484"></a>00484     
<a name="l00485"></a>00485     };
<a name="l00486"></a>00486         
<a name="l00487"></a><a class="code" href="group__Scene.html#gaa1ca4f17a1e8bb7381446ae6235869d8">00487</a>     <span class="keyword">typedef</span> std::pair&lt;MovableObject*, MovableObject*&gt; <a class="code" href="group__Scene.html#gaa1ca4f17a1e8bb7381446ae6235869d8">SceneQueryMovableObjectPair</a>;
<a name="l00488"></a><a class="code" href="group__Scene.html#gae8f394829e3a85cea6faa915ac391653">00488</a>     <span class="keyword">typedef</span> std::pair&lt;MovableObject*, SceneQuery::WorldFragment*&gt; <a class="code" href="group__Scene.html#gae8f394829e3a85cea6faa915ac391653">SceneQueryMovableObjectWorldFragmentPair</a>;
<a name="l00489"></a><a class="code" href="group__Scene.html#gaddcc5a6779ee6a6bb82aeb5f42239a52">00489</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1list.html">list&lt;SceneQueryMovableObjectPair&gt;::type</a> <a class="code" href="group__Scene.html#gaddcc5a6779ee6a6bb82aeb5f42239a52">SceneQueryMovableIntersectionList</a>;
<a name="l00490"></a><a class="code" href="group__Scene.html#ga2e63733116c49a9931a2989a2cfe1b51">00490</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1list.html">list&lt;SceneQueryMovableObjectWorldFragmentPair&gt;::type</a> <a class="code" href="group__Scene.html#ga2e63733116c49a9931a2989a2cfe1b51">SceneQueryMovableWorldFragmentIntersectionList</a>;
<a name="l00492"></a><a class="code" href="structOgre_1_1IntersectionSceneQueryResult.html">00492</a>     <span class="keyword">struct </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="structOgre_1_1IntersectionSceneQueryResult.html" title="Holds the results of an intersection scene query (pair values).">IntersectionSceneQueryResult</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">SceneMgtAlloc</a>
<a name="l00493"></a>00493     {
<a name="l00495"></a><a class="code" href="structOgre_1_1IntersectionSceneQueryResult.html#ae58676373c408a358f7cc01874703abc">00495</a>         <a class="code" href="group__Scene.html#gaddcc5a6779ee6a6bb82aeb5f42239a52">SceneQueryMovableIntersectionList</a> <a class="code" href="structOgre_1_1IntersectionSceneQueryResult.html#ae58676373c408a358f7cc01874703abc" title="List of movable / movable intersections (entities, particle systems etc)">movables2movables</a>;
<a name="l00497"></a><a class="code" href="structOgre_1_1IntersectionSceneQueryResult.html#a7f5b38d7ff668a368bcef9886fff1941">00497</a>         <a class="code" href="group__Scene.html#ga2e63733116c49a9931a2989a2cfe1b51">SceneQueryMovableWorldFragmentIntersectionList</a> <a class="code" href="structOgre_1_1IntersectionSceneQueryResult.html#a7f5b38d7ff668a368bcef9886fff1941" title="List of movable / world intersections.">movables2world</a>;
<a name="l00498"></a>00498         
<a name="l00499"></a>00499         
<a name="l00500"></a>00500 
<a name="l00501"></a>00501     };
<a name="l00502"></a>00502 
<a name="l00511"></a><a class="code" href="classOgre_1_1IntersectionSceneQuery.html">00511</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1IntersectionSceneQuery.html" title="Separate SceneQuery class to query for pairs of objects which are possibly intersecting one another...">IntersectionSceneQuery</a>
<a name="l00512"></a>00512         : <span class="keyword">public</span> <a class="code" href="classOgre_1_1SceneQuery.html" title="A class for performing queries on a scene.">SceneQuery</a>, <span class="keyword">public</span> <a class="code" href="classOgre_1_1IntersectionSceneQueryListener.html" title="Alternative listener class for dealing with IntersectionSceneQuery.">IntersectionSceneQueryListener</a> 
<a name="l00513"></a>00513     {
<a name="l00514"></a>00514     <span class="keyword">protected</span>:
<a name="l00515"></a><a class="code" href="classOgre_1_1IntersectionSceneQuery.html#a988a1401a7c5a7394045f257913f9b79">00515</a>         <a class="code" href="structOgre_1_1IntersectionSceneQueryResult.html" title="Holds the results of an intersection scene query (pair values).">IntersectionSceneQueryResult</a>* <a class="code" href="classOgre_1_1IntersectionSceneQuery.html#a988a1401a7c5a7394045f257913f9b79">mLastResult</a>;
<a name="l00516"></a>00516     <span class="keyword">public</span>:
<a name="l00517"></a>00517         <a class="code" href="classOgre_1_1IntersectionSceneQuery.html" title="Separate SceneQuery class to query for pairs of objects which are possibly intersecting one another...">IntersectionSceneQuery</a>(<a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* mgr);
<a name="l00518"></a>00518         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1IntersectionSceneQuery.html" title="Separate SceneQuery class to query for pairs of objects which are possibly intersecting one another...">IntersectionSceneQuery</a>();
<a name="l00519"></a>00519 
<a name="l00528"></a>00528         <span class="keyword">virtual</span> <a class="code" href="structOgre_1_1IntersectionSceneQueryResult.html" title="Holds the results of an intersection scene query (pair values).">IntersectionSceneQueryResult</a>&amp; execute(<span class="keywordtype">void</span>);
<a name="l00529"></a>00529 
<a name="l00537"></a>00537         <span class="keyword">virtual</span> <span class="keywordtype">void</span> execute(<a class="code" href="classOgre_1_1IntersectionSceneQueryListener.html" title="Alternative listener class for dealing with IntersectionSceneQuery.">IntersectionSceneQueryListener</a>* listener) = 0;
<a name="l00538"></a>00538 
<a name="l00542"></a>00542         <span class="keyword">virtual</span> <a class="code" href="structOgre_1_1IntersectionSceneQueryResult.html" title="Holds the results of an intersection scene query (pair values).">IntersectionSceneQueryResult</a>&amp; getLastResults(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00549"></a>00549         <span class="keyword">virtual</span> <span class="keywordtype">void</span> clearResults(<span class="keywordtype">void</span>);
<a name="l00550"></a>00550 
<a name="l00552"></a>00552         <span class="keywordtype">bool</span> queryResult(<a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>* first, <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>* second);
<a name="l00554"></a>00554         <span class="keywordtype">bool</span> queryResult(<a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>* movable, <a class="code" href="structOgre_1_1SceneQuery_1_1WorldFragment.html" title="Represents part of the world geometry that is a result of a SceneQuery.">SceneQuery::WorldFragment</a>* fragment);
<a name="l00555"></a>00555     };
<a name="l00556"></a>00556     
<a name="l00560"></a>00560 }
<a name="l00561"></a>00561     
<a name="l00562"></a>00562 
<a name="l00563"></a>00563 
<a name="l00564"></a>00564 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
